<mat-accordion>
  <mat-expansion-panel [expanded]="(editItem === undefined || editItem?.index === 0) ? true : false">
    <mat-expansion-panel-header>
      <mat-panel-title>
        <strong>Customer Info</strong>
      </mat-panel-title>
    </mat-expansion-panel-header>
    <form [formGroup]="customerInfo">
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>BP code</mat-label>
        <input matInput placeholder="" [value]="customerInfo.value.bpCode" formControlName="bpCode" maxlength="9"
          autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.bpCode">
          <mat-error class="error-message" *ngIf="  
              customerInfo.get('bpCode').hasError(validation.type) &&
                  (customerInfo.get('bpCode').dirty ||
                  customerInfo.get('bpCode').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Name</mat-label>
        <input matInput placeholder="" formControlName="name" [value]="customerInfo.value.name" maxlength="35"
          autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.name">
          <mat-error class="error-message" *ngIf="  
              customerInfo.get('name').hasError(validation.type) &&
                  (customerInfo.get('name').dirty ||
                  customerInfo.get('name').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Address</mat-label>
        <input matInput placeholder="" formControlName="streetName" [value]="customerInfo.value.streetName"
          maxlength="35" autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.streetName">
          <mat-error class="error-message" *ngIf="  
          customerInfo.get('streetName').hasError(validation.type) &&
                    (customerInfo.get('streetName').dirty ||
                    customerInfo.get('streetName').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>City</mat-label>
        <input matInput placeholder="" formControlName="city" [value]="customerInfo.value.city" maxlength="8"
          autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.city">
          <mat-error class="error-message" *ngIf="  
              customerInfo.get('city').hasError(validation.type) &&
                  (customerInfo.get('city').dirty ||
                  customerInfo.get('city').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Country</mat-label>
        <mat-select name="country" formControlName="country">
          <mat-option *ngFor="let country of countries" [value]="country">
            {{country}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.country">
          <mat-error class="error-message" *ngIf="  
                customerInfo.get('country').hasError(validation.type) &&
                    (customerInfo.get('country').dirty ||
                    customerInfo.get('country').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>VAT Number</mat-label>
        <input matInput placeholder="" maxlength="15" formControlName="vatNumber" [value]="customerInfo.value.vatNumber"
          autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.vatNumber">
          <mat-error class="error-message" *ngIf="  
              customerInfo.get('vatNumber').hasError(validation.type) &&
                  (customerInfo.get('vatNumber').dirty ||
                  customerInfo.get('vatNumber').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Currency</mat-label>
        <mat-select name="currency" formControlName="currency">
          <mat-option *ngFor="let currency of currencies" [value]="currency">
            {{currency}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.currency">
          <mat-error class="error-message" *ngIf="  
              customerInfo.get('currency').hasError(validation.type) &&
                  (customerInfo.get('currency').dirty ||
                  customerInfo.get('currency').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Terms of Payment</mat-label>
        <mat-select name="paymentTerm" formControlName="paymentTerms">
          <mat-option *ngFor="let paymentTerm of paymentTerms" [value]="paymentTerm">
            {{paymentTerm}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.PaymentTerm">
          <mat-error class="error-message" *ngIf="  
                customerInfo.get('paymentTerms').hasError(validation.type) &&
                    (customerInfo.get('paymentTerms').dirty ||
                    customerInfo.get('paymentTerms').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Terms of Delivery</mat-label>
        <mat-select name="paymentTerm" formControlName="deliveryTerms">
          <mat-option *ngFor="let deliveryTerm of deliveryTerms" [value]="deliveryTerm">
            {{deliveryTerm}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.DeliveryTerm">
          <mat-error class="error-message" *ngIf="  
                customerInfo.get('deliveryTerms').hasError(validation.type) &&
                    (customerInfo.get('deliveryTerms').dirty ||
                    customerInfo.get('deliveryTerms').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Financial Group</mat-label>
        <mat-select name="currency" formControlName="financialGroup">
          <mat-option *ngFor="let financialGroup of financialGroups" [value]="financialGroup">
            {{financialGroup}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.financialGroup">
          <mat-error class="error-message" *ngIf="  
              customerInfo.get('financialGroup').hasError(validation.type) &&
                  (customerInfo.get('financialGroup').dirty ||
                  customerInfo.get('financialGroup').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Bank Name</mat-label>
        <mat-select name="bankName" formControlName="bank">
          <mat-option *ngFor="let bank of availableBanks" [value]="bank">
            {{bank}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.bank">
          <mat-error class="error-message" *ngIf="  
              customerInfo.get('bank').hasError(validation.type) &&
                  (customerInfo.get('bank').dirty ||
                  customerInfo.get('bank').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
    </form>
  </mat-expansion-panel>
  <mat-expansion-panel [expanded]="editItem?.index === 1">
    <mat-expansion-panel-header>
      <mat-panel-title>
        <strong>Supplier Info</strong>
      </mat-panel-title>
    </mat-expansion-panel-header>
    <form [formGroup]="supplierInfo">
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>BP code</mat-label>
        <input matInput placeholder="" [value]="supplierInfo.value.bpCode" formControlName="bpCode" maxlength="9"
          autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.bpCode">
          <mat-error class="error-message" *ngIf="  
                supplierInfo.get('bpCode').hasError(validation.type) &&
                    (supplierInfo.get('bpCode').dirty ||
                    supplierInfo.get('bpCode').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Name</mat-label>
        <input matInput placeholder="" formControlName="name" [value]="supplierInfo.value.name" maxlength="35"
          autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.name">
          <mat-error class="error-message" *ngIf="  
                supplierInfo.get('name').hasError(validation.type) &&
                    (supplierInfo.get('name').dirty ||
                    supplierInfo.get('name').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Address</mat-label>
        <input matInput placeholder="" formControlName="streetName" [value]="supplierInfo.value.streetName"
          maxlength="35" autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.streetName">
          <mat-error class="error-message" *ngIf="  
                supplierInfo.get('streetName').hasError(validation.type) &&
                    (supplierInfo.get('streetName').dirty ||
                    supplierInfo.get('streetName').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>City</mat-label>
        <input matInput placeholder="" formControlName="city" [value]="supplierInfo.value.city" maxlength="8"
          autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.city">
          <mat-error class="error-message" *ngIf="  
                supplierInfo.get('city').hasError(validation.type) &&
                    (supplierInfo.get('city').dirty ||
                    supplierInfo.get('city').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Country</mat-label>
        <mat-select name="country" formControlName="country">
          <mat-option *ngFor="let country of countries" [value]="country">
            {{country}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.country">
          <mat-error class="error-message" *ngIf="  
                  supplierInfo.get('country').hasError(validation.type) &&
                      (supplierInfo.get('country').dirty ||
                      supplierInfo.get('country').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>VAT Number</mat-label>
        <input matInput placeholder="" formControlName="vatNumber" [value]="supplierInfo.value.vatNumber" maxlength="15"
          autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.vatNumber">
          <mat-error class="error-message" *ngIf="  
                supplierInfo.get('vatNumber').hasError(validation.type) &&
                    (supplierInfo.get('vatNumber').dirty ||
                    supplierInfo.get('vatNumber').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Currency</mat-label>
        <mat-select name="currency" formControlName="currency">
          <mat-option *ngFor="let currency of currencies" [value]="currency">
            {{currency}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.currency">
          <mat-error class="error-message" *ngIf="  
                  supplierInfo.get('currency').hasError(validation.type) &&
                      (supplierInfo.get('currency').dirty ||
                      supplierInfo.get('currency').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Terms of Payment</mat-label>
        <mat-select name="paymentTerm" formControlName="paymentTerm">
          <mat-option *ngFor="let paymentTerm of paymentTerms" [value]="paymentTerm">
            {{paymentTerm}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.paymentTerm">
          <mat-error class="error-message" *ngIf="  
                  supplierInfo.get('paymentTerm').hasError(validation.type) &&
                      (supplierInfo.get('paymentTerm').dirty ||
                      supplierInfo.get('paymentTerm').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Financial Group</mat-label>
        <mat-select name="currency" formControlName="financialGroup">
          <mat-option *ngFor="let financialGroup of financialGroups" [value]="financialGroup">
            {{financialGroup}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.financialGroup">
          <mat-error class="error-message" *ngIf="  
                supplierInfo.get('financialGroup').hasError(validation.type) &&
                    (supplierInfo.get('financialGroup').dirty ||
                    supplierInfo.get('financialGroup').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Bank Name</mat-label>
        <mat-select name="bankName" formControlName="bank">
          <mat-option *ngFor="let bank of availableBanks" [value]="bank">
            {{bank}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.bank">
          <mat-error class="error-message" *ngIf="  
                supplierInfo.get('bank').hasError(validation.type) &&
                    (supplierInfo.get('bank').dirty ||
                    supplierInfo.get('bank').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
    </form>
  </mat-expansion-panel>
  <mat-expansion-panel [expanded]="editItem?.index === 3">
    <mat-expansion-panel-header>
      <mat-panel-title>
        <strong>Item Info</strong>
      </mat-panel-title>
    </mat-expansion-panel-header>
    <form [formGroup]="itemInfo">
      <mat-form-field appearance="standard">
        <mat-label>Item Code</mat-label>
        <input matInput formControlName="itemCode" placeholder="" [value]="itemInfo.value.itemCode" maxlength="35"
          autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.itemCode">
          <mat-error class="error-message" *ngIf="  
            itemInfo.get('itemCode').hasError(validation.type) &&
                (itemInfo.get('itemCode').dirty ||
                itemInfo.get('itemCode').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field appearance="standard">
        <mat-label>Description</mat-label>
        <input type="text" matInput placeholder="" formControlName="description" maxlength="35"
          [value]="itemInfo.value.description" autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.description">
          <mat-error class="error-message" *ngIf="  
            itemInfo.get('description').hasError(validation.type) &&
                (itemInfo.get('description').dirty ||
                itemInfo.get('description').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field appearance="standard">
        <mat-label>Item Type</mat-label>
        <mat-select formControlName="itemType" [(value)]="itemInfo.value.itemType">
          <mat-option [value]="'Purchase'">Purchase</mat-option>
          <mat-option [value]="'Manufacturing '">Manufacturing </mat-option>
          <mat-option [value]="'Cost'">Cost</mat-option>
          <mat-option [value]="'Service'">Service</mat-option>
          <mat-option [value]="'List'">List</mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.itemType">
          <mat-error class="error-message" *ngIf="  
            itemInfo.get('itemType').hasError(validation.type) &&
                (itemInfo.get('itemType').dirty ||
                itemInfo.get('itemType').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field appearance="standard" [ngClass]="{'sub-list' : showItemGroupField}">
        <mat-label>Item Group</mat-label>
        <input *ngIf='!(itemGroup?.length > 0)' type="text" matInput placeholder="" formControlName="itemGroup"
          [value]="itemInfo.value.othersitemgroup" required autocomplete="off" />
        <mat-select *ngIf='(itemGroup?.length > 0)' formControlName="itemGroup">
          <mat-option *ngFor="let item of itemGroup" [value]="item.itemGroup" (onSelectionChange)="checkOthers($event, item)">
            {{item.itemGroup}}
          </mat-option>
          <mat-option value="Others" (onSelectionChange)="checkOthers($event, 'Others')">
            Others
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.itemGroup">
          <mat-error class="error-message" *ngIf="  
            itemInfo.get('itemGroup').hasError(validation.type) &&
                (itemInfo.get('itemGroup').dirty ||
                itemInfo.get('itemGroup').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field *ngIf="showItemGroupField" class="sub-list" appearance="standard"
        [ngClass]="{'sub-list' : showItemGroupField}">
        <mat-label>Other Item Group</mat-label>
        <input type="text" matInput formControlName="othersitemgroup" placeholder="" required autocomplete="off" />
      </mat-form-field>
      <mat-form-field appearance="standard">
        <mat-label>Ware House</mat-label>
        <input type="text" *ngIf='!(warehouses?.length > 0)' matInput placeholder="" formControlName="warehouse" maxlength="6"
          [value]="itemInfo.value.warehouse" autocomplete="off" required />
          <mat-select *ngIf='(warehouses?.length > 0)' formControlName="warehouse">
            <mat-option *ngFor="let warehouse of warehouses" [value]="warehouse.code">
              {{warehouse.code}} - {{warehouse.description}}
            </mat-option>
          </mat-select>
        <mat-error *ngFor="let validation of validationMessages.warehouse">
          <mat-error class="error-message" *ngIf="  
            itemInfo.get('warehouse').hasError(validation.type) &&
                (itemInfo.get('warehouse').dirty ||
                itemInfo.get('warehouse').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field appearance="standard">
        <mat-label>Quantity</mat-label>
        <input type="number" matInput placeholder="" formControlName="quantity" maxlength="35"
          [value]="itemInfo.value.quantity" autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.quantity">
          <mat-error class="error-message" *ngIf="  
            itemInfo.get('quantity').hasError(validation.type) &&
                (itemInfo.get('quantity').dirty ||
                itemInfo.get('quantity').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field appearance="standard">
        <mat-label>Item Group Description</mat-label>
        <input type="text" matInput placeholder="" [value]="" formControlName="itemGroupDescription"
          autocomplete="off" required />
      </mat-form-field>
      <mat-form-field appearance="standard">
        <mat-label>Inventory Unit</mat-label>
        <mat-select name="currency" formControlName="inventoryUnit">
          <mat-option *ngFor="let inventoryUnit of inventoryUnits" [value]="inventoryUnit.code">
            {{inventoryUnit.name}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.inventoryUnit">
          <mat-error class="error-message" *ngIf="  
            itemInfo.get('inventoryUnit').hasError(validation.type) &&
                (itemInfo.get('inventoryUnit').dirty ||
                itemInfo.get('inventoryUnit').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field appearance="standard">
        <mat-label>Currency</mat-label>
        <mat-select name="currency" formControlName="currency">
          <mat-option *ngFor="let currency of currencies" [value]="currency">
            {{currency}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.currency">
          <mat-error class="error-message" *ngIf="  
            itemInfo.get('currency').hasError(validation.type) &&
                (itemInfo.get('currency').dirty ||
                itemInfo.get('currency').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field appearance="standard">
        <mat-label>Purchase Price</mat-label>
        <input type="number" matInput placeholder="" [value]="itemInfo.value.purchasePrice"
          formControlName="purchasePrice" autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.purchasePrice">
          <mat-error class="error-message" *ngIf="  
            itemInfo.get('purchasePrice').hasError(validation.type) &&
                (itemInfo.get('purchasePrice').dirty ||
                itemInfo.get('purchasePrice').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field appearance="standard">
        <mat-label>Sales Price</mat-label>
        <input type="number" matInput placeholder="" [value]="itemInfo.value.salesPrice" formControlName="salesPrice"
          autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.salesPrice">
          <mat-error class="error-message" *ngIf="  
            itemInfo.get('salesPrice').hasError(validation.type) &&
                (itemInfo.get('salesPrice').dirty ||
                itemInfo.get('salesPrice').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
    </form>
  </mat-expansion-panel>
  <mat-expansion-panel [expanded]="editItem?.index === 7">
    <mat-expansion-panel-header>
      <mat-panel-title>
        <strong> WareHouse Info </strong>
      </mat-panel-title>
    </mat-expansion-panel-header>
    <form [formGroup]="wareHouseInfo">
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Code</mat-label>
        <input matInput placeholder="" [value]="wareHouseInfo.value.code" formControlName="code" autocomplete="off"
          maxlength="6" required />
        <mat-error *ngFor="let validation of validationMessages.code">
          <mat-error class="error-message" *ngIf="  
              wareHouseInfo.get('code').hasError(validation.type) &&
                  (wareHouseInfo.get('code').dirty ||
                  wareHouseInfo.get('code').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Description</mat-label>
        <input matInput placeholder="" [value]="wareHouseInfo.value.description" formControlName="description"
          autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.description">
          <mat-error class="error-message" *ngIf="  
              wareHouseInfo.get('description').hasError(validation.type) &&
                  (wareHouseInfo.get('description').dirty ||
                  wareHouseInfo.get('description').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
    </form>
  </mat-expansion-panel>

  <mat-expansion-panel [expanded]="editItem?.index === 6">
    <mat-expansion-panel-header>
      <mat-panel-title>
        <strong> Fixed Asset Details </strong>
      </mat-panel-title>
    </mat-expansion-panel-header>
    <form [formGroup]="fixedAssetInfo">
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Asset Code</mat-label>
        <input matInput placeholder="" [value]="fixedAssetInfo.value.assetCode" formControlName="assetCode"
          autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.assetCode">
          <mat-error class="error-message" *ngIf="  
              fixedAssetInfo.get('assetCode').hasError(validation.type) &&
                  (fixedAssetInfo.get('assetCode').dirty ||
                  fixedAssetInfo.get('assetCode').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Asset Name</mat-label>
        <input matInput placeholder="" [value]="fixedAssetInfo.value.assetName" formControlName="assetName"
          autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.assetName">
          <mat-error class="error-message" *ngIf="  
              fixedAssetInfo.get('assetName').hasError(validation.type) &&
                  (fixedAssetInfo.get('assetName').dirty ||
                  fixedAssetInfo.get('assetName').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>

      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Asset Extension</mat-label>
        <input matInput placeholder="" [value]="fixedAssetInfo.value.assetExtension" formControlName="assetExtension"
          autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.assetExtension">
          <mat-error class="error-message" *ngIf="  
            fixedAssetInfo.get('assetExtension').hasError(validation.type) &&
                (fixedAssetInfo.get('assetExtension').dirty ||
                fixedAssetInfo.get('assetExtension').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>

      <mat-form-field appearance="standard">
        <mat-label>Asset Group</mat-label>
        <mat-select formControlName="group" [(value)]="fixedAssetInfo.value.group">
          <mat-option [value]="'AIR CONDITIONERS & COOLERS'">AIR CONDITIONERS & COOLERS</mat-option>
          <mat-option [value]="'BUILDING'">BUILDING </mat-option>
          <mat-option [value]="'COMPUTERS & SOFTWARES'">COMPUTERS & SOFTWARES</mat-option>
          <mat-option [value]="'TOOLS & EQUIPMENT'">TOOLS & EQUIPMENT</mat-option>
          <mat-option [value]="'FURNITURE & FIXTURES'">FURNITURE & FIXTURES</mat-option>
          <mat-option [value]="'HOUSEHOLD EQUIPMENT'">HOUSEHOLD EQUIPMENT</mat-option>
          <mat-option [value]="'LEASE VEHILCE'">LEASE VEHILCE</mat-option>
          <mat-option [value]="'VEHICLE'">VEHICLE</mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.group">
          <mat-error class="error-message" *ngIf="  
            fixedAssetInfo.get('group').hasError(validation.type) &&
                (fixedAssetInfo.get('group').dirty ||
                fixedAssetInfo.get('group').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>

      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Asset Category</mat-label>
        <mat-select formControlName="category" [(value)]="fixedAssetInfo.value.category">
          <mat-option *ngFor="let item of assetCategory" [value]="item">
            {{item}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.category">
          <mat-error class="error-message" *ngIf="  
          fixedAssetInfo.get('category').hasError(validation.type) &&
              (fixedAssetInfo.get('category').dirty ||
              fixedAssetInfo.get('category').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>

      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Tag</mat-label>
        <input matInput placeholder="Tag" [value]="fixedAssetInfo.value.description" formControlName="description"
          autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.assetdescription">
          <mat-error class="error-message" *ngIf="  
          fixedAssetInfo.get('description').hasError(validation.type) &&
              (fixedAssetInfo.get('description').dirty ||
              fixedAssetInfo.get('description').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>

      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Service Date</mat-label>
        <input matInput readonly [matDatepicker]="dPicker1" formControlName="serviceDate">
        <mat-datepicker-toggle matSuffix [for]="dPicker1"></mat-datepicker-toggle>
        <mat-datepicker #dPicker1></mat-datepicker>
      </mat-form-field>

      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Purchase Date</mat-label>
        <input matInput readonly [matDatepicker]="dPicker2" formControlName="purchaseDate">
        <mat-datepicker-toggle matSuffix [for]="dPicker2"></mat-datepicker-toggle>
        <mat-datepicker #dPicker2></mat-datepicker>
      </mat-form-field>

      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Transaction Cost</mat-label>
        <input matInput type="number" placeholder="" [value]="fixedAssetInfo.value.transactionCost"
          formControlName="transactionCost" autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.transactionCost">
          <mat-error class="error-message" *ngIf="  
          fixedAssetInfo.get('transactionCost').hasError(validation.type) &&
              (fixedAssetInfo.get('transactionCost').dirty ||
              fixedAssetInfo.get('transactionCost').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>

      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Transaction Currency</mat-label>
        <mat-select name="transactionCurrency" formControlName="transactionCurrency">
          <mat-option *ngFor="let currency of currencies" [value]="currency">
            {{currency}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.transactionCurrency">
          <mat-error class="error-message" *ngIf="  
          fixedAssetInfo.get('transactionCurrency').hasError(validation.type) &&
              (fixedAssetInfo.get('transactionCurrency').dirty ||
              fixedAssetInfo.get('transactionCurrency').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>

      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Life Month</mat-label>
        <input matInput type="text" placeholder="" [value]="fixedAssetInfo.value.assetLifeMonth"
          formControlName="assetLifeMonth" autocomplete="off" />
        <mat-error *ngFor="let validation of validationMessages.assetLifeMonth">
          <mat-error class="error-message" *ngIf="  
          fixedAssetInfo.get('assetLifeMonth').hasError(validation.type) &&
              (fixedAssetInfo.get('assetLifeMonth').dirty ||
              fixedAssetInfo.get('assetLifeMonth').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>

      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Life Year</mat-label>
        <input matInput type="text" placeholder="" [value]="fixedAssetInfo.value.assetLifeYear"
          formControlName="assetLifeYear" autocomplete="off" />
        <mat-error *ngFor="let validation of validationMessages.assetLifeYear">
          <mat-error class="error-message" *ngIf="  
          fixedAssetInfo.get('assetLifeYear').hasError(validation.type) &&
              (fixedAssetInfo.get('assetLifeYear').dirty ||
              fixedAssetInfo.get('assetLifeYear').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
    </form>
  </mat-expansion-panel>
  <mat-expansion-panel [expanded]="editItem?.index === 8">
    <mat-expansion-panel-header>
      <mat-panel-title>
        <strong> Ledger Account Details </strong>
      </mat-panel-title>
    </mat-expansion-panel-header>
    <form [formGroup]="ledgerAccount">
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Account Number</mat-label>
        <input matInput placeholder="" [value]="ledgerAccount.value.accountNumber" formControlName="accountNumber"
          maxlength="12" autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.accountNumber">
          <mat-error class="error-message" *ngIf="  
            ledgerAccount.get('accountNumber').hasError(validation.type) &&
                    (ledgerAccount.get('accountNumber').dirty ||
                    ledgerAccount.get('accountNumber').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Description</mat-label>
        <input matInput placeholder="" [value]="ledgerAccount.value.description" formControlName="description"
          maxlength="30" autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.description">
          <mat-error class="error-message" *ngIf="  
          ledgerAccount.get('description').hasError(validation.type) &&
                  (ledgerAccount.get('description').dirty ||
                  ledgerAccount.get('description').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Search Key</mat-label>
        <input matInput placeholder="" [value]="ledgerAccount.value.searchKey" formControlName="searchKey"
          maxlength="16" autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.searchKey">
          <mat-error class="error-message" *ngIf="  
          ledgerAccount.get('searchKey').hasError(validation.type) &&
                  (ledgerAccount.get('searchKey').dirty ||
                  ledgerAccount.get('searchKey').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Sub Level</mat-label>
        <input type="number" (keyup)="checkLimit('ledgerAccount', 'subLevel', 2)" matInput placeholder=""
          [value]="ledgerAccount.value.subLevel" formControlName="subLevel" autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.subLevel">
          <mat-error class="error-message" *ngIf="  
          ledgerAccount.get('subLevel').hasError(validation.type) &&
                  (ledgerAccount.get('subLevel').dirty ||
                  ledgerAccount.get('subLevel').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Parent Ledger</mat-label>
        <input matInput placeholder="" [value]="ledgerAccount.value.parentLedger" formControlName="parentLedger"
          maxlength="12" autocomplete="off" />
        <mat-error *ngFor="let validation of validationMessages.parentLedger">
          <mat-error class="error-message" *ngIf="  
          ledgerAccount.get('parentLedger').hasError(validation.type) &&
                  (ledgerAccount.get('parentLedger').dirty ||
                  ledgerAccount.get('parentLedger').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Account Type</mat-label>
        <mat-select formControlName="accountType" [(value)]="ledgerAccount.value.accountType">
          <mat-option *ngFor="let accountType of accountTypes" [value]="accountType">
            {{accountType}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.accountType">
          <mat-error class="error-message" *ngIf="  
          ledgerAccount.get('accountType').hasError(validation.type) &&
                  (ledgerAccount.get('accountType').dirty ||
                  ledgerAccount.get('accountType').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Ledger Type</mat-label>
        <mat-select formControlName="type" [(value)]="ledgerAccount.value.type">
          <mat-option *ngFor="let type of transactionTypes" [value]="type">
            {{type}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.type">
          <mat-error class="error-message" *ngIf="  
          ledgerAccount.get('type').hasError(validation.type) &&
                  (ledgerAccount.get('type').dirty ||
                  ledgerAccount.get('type').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Ledger Status</mat-label>
        <mat-select formControlName="status" [(value)]="ledgerAccount.value.status">
          <mat-option *ngFor="let status of ledgerStatus" [value]="status">
            {{status}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.status">
          <mat-error class="error-message" *ngIf="  
          ledgerAccount.get('status').hasError(validation.status) &&
                  (ledgerAccount.get('status').dirty ||
                  ledgerAccount.get('status').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Dimension One</mat-label>
        <mat-select formControlName="dimension1" [(value)]="ledgerAccount.value.dimension1">
          <mat-option *ngFor="let dimension of dimensionStatus" [value]="dimension">
            {{dimension}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.dimension1">
          <mat-error class="error-message" *ngIf="  
          ledgerAccount.get('dimension1').hasError(validation.dimension1) &&
                  (ledgerAccount.get('dimension1').dirty ||
                  ledgerAccount.get('dimension1').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Dimension Two</mat-label>
        <mat-select formControlName="dimension2" [(value)]="ledgerAccount.value.dimension2">
          <mat-option *ngFor="let dimension of dimensionStatus" [value]="dimension">
            {{dimension}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.dimension2">
          <mat-error class="error-message" *ngIf="  
            ledgerAccount.get('dimension2').hasError(validation.dimension2) &&
                    (ledgerAccount.get('dimension2').dirty ||
                    ledgerAccount.get('dimension2').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Dimension Three</mat-label>
        <mat-select formControlName="dimension3" [(value)]="ledgerAccount.value.dimension3">
          <mat-option *ngFor="let dimension of dimensionStatus" [value]="dimension">
            {{dimension}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.dimension3">
          <mat-error class="error-message" *ngIf="  
              ledgerAccount.get('dimension3').hasError(validation.dimension1) &&
                      (ledgerAccount.get('dimension3').dirty ||
                      ledgerAccount.get('dimension3').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Dimension Four</mat-label>
        <mat-select formControlName="dimension4" [(value)]="ledgerAccount.value.dimension4">
          <mat-option *ngFor="let dimension of dimensionStatus" [value]="dimension">
            {{dimension}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.dimension4">
          <mat-error class="error-message" *ngIf="  
                ledgerAccount.get('dimension4').hasError(validation.dimension4) &&
                        (ledgerAccount.get('dimension4').dirty ||
                        ledgerAccount.get('dimension4').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Dimension Five</mat-label>
        <mat-select formControlName="dimension5" [(value)]="ledgerAccount.value.dimension5">
          <mat-option *ngFor="let dimension of dimensionStatus" [value]="dimension">
            {{dimension}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.dimension5">
          <mat-error class="error-message" *ngIf="  
                  ledgerAccount.get('dimension5').hasError(validation.dimension5) &&
                          (ledgerAccount.get('dimension5').dirty ||
                          ledgerAccount.get('dimension5').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
    </form>
  </mat-expansion-panel>

  <mat-expansion-panel [expanded]="editItem?.index === 9">
    <mat-expansion-panel-header>
      <mat-panel-title>
        <strong> Period </strong>
      </mat-panel-title>
    </mat-expansion-panel-header>
    <form [formGroup]="periodFormGroup">
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Period Type</mat-label>
        <mat-select formControlName="periodType">
          <mat-option *ngFor="let period of periodTypeDropDown" [value]="period">
            {{period}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.periodType">
          <mat-error class="error-message" *ngIf="  
              periodFormGroup.get('periodType').hasError(validation.type) &&
                      (periodFormGroup.get('periodType').dirty ||
                      periodFormGroup.get('periodType').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Year</mat-label>
        <input matInput type="number" placeholder="Year" formControlName="year"
          oninput="javascript: if (this.value.length > this.maxLength) this.value = this.value.slice(0, this.maxLength);"
          maxlength="4" autocomplete="off" />
        <mat-error *ngFor="let validation of validationMessages.year">
          <mat-error class="error-message" *ngIf="  
                periodFormGroup.get('year').hasError(validation.type) &&
                        (periodFormGroup.get('year').dirty ||
                        periodFormGroup.get('year').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Period</mat-label>
        <input matInput type="number" placeholder="period" formControlName="period"
          oninput="javascript: if (this.value > 13) this.value = this.value - (this.value-13);" maxlength="4"
          autocomplete="off" />
        <mat-error *ngFor="let validation of validationMessages.period">
          <mat-error class="error-message" *ngIf="  
                periodFormGroup.get('period').hasError(validation.type) &&
                        (periodFormGroup.get('period').dirty ||
                        periodFormGroup.get('period').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Start Date</mat-label>
        <input matInput readonly [matDatepicker]="dPicker3" formControlName="startDate">
        <mat-datepicker-toggle matSuffix [for]="dPicker3"></mat-datepicker-toggle>
        <mat-datepicker #dPicker3></mat-datepicker>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Description</mat-label>
        <input matInput type="text" placeholder="description" formControlName="description"
          oninput="javascript: if (this.value.length > this.maxLength) this.value = this.value.slice(0, this.maxLength);"
          maxlength="15" autocomplete="off" />
        <mat-error *ngFor="let validation of validationMessages.descriptionPeriod">
          <mat-error class="error-message" *ngIf="  
                periodFormGroup.get('description').hasError(validation.type) &&
                        (periodFormGroup.get('description').dirty ||
                        periodFormGroup.get('description').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Correction Period</mat-label>
        <mat-select formControlName="correctionPeriod">
          <mat-option *ngFor="let period of correctionPeriodDropDown" [value]="period">
            {{period}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.correctionPeriod">
          <mat-error class="error-message" *ngIf="  
                periodFormGroup.get('correctionPeriod').hasError(validation.type) &&
                        (periodFormGroup.get('correctionPeriod').dirty ||
                        periodFormGroup.get('correctionPeriod').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>AP</mat-label>
        <mat-select formControlName="status1">
          <mat-option value="Open">Open</mat-option>
          <mat-option value="Closed">Closed</mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.status1">
          <mat-error class="error-message" *ngIf="  
                periodFormGroup.get('status1').hasError(validation.type) &&
                        (periodFormGroup.get('status1').dirty ||
                        periodFormGroup.get('status1').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>AR</mat-label>
        <mat-select formControlName="status2">
          <mat-option value="Open">Open</mat-option>
          <mat-option value="Closed">Closed</mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.status2">
          <mat-error class="error-message" *ngIf="  
                periodFormGroup.get('status2').hasError(validation.type) &&
                        (periodFormGroup.get('status2').dirty ||
                        periodFormGroup.get('status2').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>CMG</mat-label>
        <mat-select formControlName="status3">
          <mat-option value="Open">Open</mat-option>
          <mat-option value="Closed">Closed</mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.status3">
          <mat-error class="error-message" *ngIf="  
                periodFormGroup.get('status3').hasError(validation.type) &&
                        (periodFormGroup.get('status3').dirty ||
                        periodFormGroup.get('status3').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>INT</mat-label>
        <mat-select formControlName="status4">
          <mat-option value="Open">Open</mat-option>
          <mat-option value="Closed">Closed</mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.status4">
          <mat-error class="error-message" *ngIf="  
                periodFormGroup.get('status4').hasError(validation.type) &&
                        (periodFormGroup.get('status4').dirty ||
                        periodFormGroup.get('status4').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>GLD</mat-label>
        <mat-select formControlName="status5">
          <mat-option value="Open">Open</mat-option>
          <mat-option value="Closed">Closed</mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.status5">
          <mat-error class="error-message" *ngIf="  
                periodFormGroup.get('status5').hasError(validation.type) &&
                        (periodFormGroup.get('status5').dirty ||
                        periodFormGroup.get('status5').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
    </form>
  </mat-expansion-panel>

  <mat-expansion-panel [expanded]="editItem?.index === 10">
    <mat-expansion-panel-header>
      <mat-panel-title>
        <strong> Dimension </strong>
      </mat-panel-title>
    </mat-expansion-panel-header>
    <form [formGroup]="dimensionFormGroup">
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Code</mat-label>
        <input matInput placeholder="" [value]="dimensionFormGroup.value.code" formControlName="code" maxlength="6"
          autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.code">
          <mat-error class="error-message" *ngIf="  
            dimensionFormGroup.get('code').hasError(validation.type) &&
                    (dimensionFormGroup.get('code').dirty ||
                    dimensionFormGroup.get('code').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Description</mat-label>
        <input matInput placeholder="" [value]="dimensionFormGroup.value.description" formControlName="description"
          maxlength="15" autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.description">
          <mat-error class="error-message" *ngIf="  
            dimensionFormGroup.get('description').hasError(validation.type) &&
                    (dimensionFormGroup.get('description').dirty ||
                    dimensionFormGroup.get('description').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Sub Level</mat-label>
        <input matInput placeholder="" type="number" (keyup)="checkLimit('dimensionFormGroup', 'subLevel', 2)"
          [value]="dimensionFormGroup.value.subLevel" formControlName="subLevel" autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.subLevel">
          <mat-error class="error-message" *ngIf="  
            dimensionFormGroup.get('subLevel').hasError(validation.type) &&
                    (dimensionFormGroup.get('subLevel').dirty ||
                    dimensionFormGroup.get('subLevel').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Dimension Type</mat-label>
        <mat-select formControlName="dimensionType" [(value)]="dimensionFormGroup.value.dimensionType">
          <mat-option *ngFor="let dimension of dimensionTypes" [value]="dimension">
            {{dimension}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.dimensionType">
          <mat-error class="error-message" *ngIf="  
            dimensionFormGroup.get('dimensionType').hasError(validation.type) &&
                    (dimensionFormGroup.get('dimensionType').dirty ||
                    dimensionFormGroup.get('dimensionType').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Parent Dimension</mat-label>
        <input matInput placeholder="" [value]="dimensionFormGroup.value.parentDimension"
          formControlName="parentDimension" maxlength="6" autocomplete="off" />
      </mat-form-field>
    </form>
  </mat-expansion-panel>

  <mat-expansion-panel [expanded]="editItem?.index === 12">
    <mat-expansion-panel-header>
      <mat-panel-title>
        <strong> Sales Rrepresentative </strong>
      </mat-panel-title>
    </mat-expansion-panel-header>
    <form [formGroup]="SalesRepFormGroup">
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Code</mat-label>
        <input matInput placeholder="" [value]="SalesRepFormGroup.value.key" formControlName="key"
          autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.key">
          <mat-error class="error-message" *ngIf="  
          SalesRepFormGroup.get('key').hasError(validation.type) &&
                    (SalesRepFormGroup.get('key').dirty ||
                    SalesRepFormGroup.get('key').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Description</mat-label>
        <input matInput placeholder="" [value]="SalesRepFormGroup.value.value" formControlName="value"
          autocomplete="off" required />
        <mat-error *ngFor="let validation of validationMessages.value">
          <mat-error class="error-message" *ngIf="  
          SalesRepFormGroup.get('value').hasError(validation.type) &&
                    (SalesRepFormGroup.get('value').dirty ||
                    SalesRepFormGroup.get('value').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
    </form>
  </mat-expansion-panel>
  <mat-expansion-panel [expanded]="editItem?.index === 11">
    <mat-expansion-panel-header>
      <mat-panel-title>
        <strong> VAT Details </strong>
      </mat-panel-title>
    </mat-expansion-panel-header>
    <form [formGroup]="VATFormGroup" class="vat-form">
      <ul>
        <li *ngFor="let vat of vatArr.controls; let i = index" [formGroup]="vat">
          <span class="s-no"> {{i+1}}</span>
          <mat-form-field class="vat-field" appearance="standard">
            <mat-label>VAT Code</mat-label>
            <input matInput placeholder="" formControlName="vatCode" autocomplete="off" />
          </mat-form-field>
          <mat-form-field class="vat-field" appearance="standard">
            <mat-label>VAT Description</mat-label>
            <input matInput placeholder="" formControlName="vatDescription" autocomplete="off" />
          </mat-form-field>
          <mat-form-field class="vat-field" appearance="standard">
            <mat-label>VAT %</mat-label>
            <input type="number" matInput placeholder="" formControlName="vatPercentage" autocomplete="off" />
          </mat-form-field>
        </li>
      </ul>
    </form>
  </mat-expansion-panel>

  <mat-expansion-panel [expanded]="false">
    <mat-expansion-panel-header>
      <mat-panel-title>
        <strong> Currency Rate </strong>
      </mat-panel-title>
    </mat-expansion-panel-header>
    <form [formGroup]="currencyFormGroup">
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Currency Code</mat-label>
        <mat-select formControlName="currency" multiple>
          <mat-option *ngFor="let item of currenciesRate" value="item.isocode" (onSelectionChange)="updateSelect($event, item)">{{item.isocode}} - {{item.conversion}}</mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.currency">
          <mat-error class="error-message" *ngIf="  
          currencyFormGroup.get('currency').hasError(validation.type) &&
                        (currencyFormGroup.get('currency').dirty ||
                        currencyFormGroup.get('currency').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>

      <section class="po-list">
        <ul>
          <li *ngFor="let item of rateArr.controls; let i = index" [formGroup]="item">
            <span class="s-no">{{i+1}}</span>
            <mat-form-field>
              <mat-label>Currency</mat-label>
              <input matInput placeholder="Currency" formControlName="key" required disabled>
            </mat-form-field>
            <mat-form-field>
              <mat-label>Conversion Rate</mat-label>
              <input matInput placeholder="Conversion Rate" formControlName="value" required disabled>
            </mat-form-field>
            <div class="button-item">
              <button mat-mini-fab class="add-remove-item remove" (click)="remove(i, item)">-</button>
            </div>
          </li>
        </ul>
      </section>
    </form>
  </mat-expansion-panel>
</mat-accordion>
<button mat-raised-button (click)="onSubmitForm()"
  [disabled]="customerInfo.invalid && supplierInfo.invalid && itemInfo.invalid && wareHouseInfo.invalid && fixedAssetInfo.invalid && ledgerAccount.invalid && dimensionFormGroup.invalid && periodFormGroup.invalid && VATFormGroup.invalid"
  class="submit-btn">
  {{buttonName}}
</button>